Package org.opensaml.saml.metadata.resolver.index.impl

# Class RoleMetadataIndex

java.lang.Object
org.opensaml.saml.metadata.resolver.index.impl.RoleMetadataIndex

All Implemented Interfaces:
  `MetadataIndex`

public class RoleMetadataIndex extends Object implements MetadataIndex
An implementation of `MetadataIndex` which indexes entities by their roles.

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected static class`
`RoleMetadataIndex.RoleMetadataIndexKey`
An implementation of `MetadataIndexKey` representing a single SAML metadata role.

## Constructor Summary

Constructors
Constructor
Description
`RoleMetadataIndex()`

## Method Summary

Modifier and Type
Method
Description
`Set<MetadataIndexKey>`
`generateKeys(CriteriaSet criteriaSet)`
Generate a set of one or more `MetadataIndexKey` instances based on the input `CriteriaSet`.
`Set<MetadataIndexKey>`
`generateKeys(EntityDescriptor descriptor)`
Generate a set of one or more `MetadataIndexKey` instances based on the input `EntityDescriptor`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### RoleMetadataIndex

public RoleMetadataIndex()

## Method Details

### generateKeys

@Nullable @Unmodifiable @NotLive public Set<MetadataIndexKey> generateKeys(@Nullable CriteriaSet criteriaSet)
Generate a set of one or more `MetadataIndexKey` instances based on the input `CriteriaSet`.

These index key instances reflect the type of indexing performed and "understood" by the implementation, and as such should complement the `MetadataIndexKey` types generated for descriptor indexing via `MetadataIndex.generateKeys(EntityDescriptor)`.

Specified by:
  `generateKeys` in interface `MetadataIndex`
Parameters:
  `criteriaSet` - the criteria set to process
Returns:
  the set of index keys generated from the criteria. May be null or empty, but will not contain null elements.

### generateKeys

@Nullable @Unmodifiable @NotLive public Set<MetadataIndexKey> generateKeys(@Nonnull EntityDescriptor descriptor)
Generate a set of one or more `MetadataIndexKey` instances based on the input `EntityDescriptor`.

These index key instances reflect the type of indexing performed and "understood" by the implementation, and as such should complement the `MetadataIndexKey` types generated for descriptor lookup via `MetadataIndex.generateKeys(CriteriaSet)`.

Specified by:
  `generateKeys` in interface `MetadataIndex`
Parameters:
  `descriptor` - the entity descriptor set to process
Returns:
  the set of index keys generated from the criteria. May be null or empty, but will not contain null elements.